routes/web.php
<?php


/* --------------------- Common/User Routes START -------------------------------- */

Route::get('/', function () {
    // return view('welcome');
    return redirect('admin/dashboard');
});

Auth::routes(['verify' => true]);

Route::get('/home', 'HomeController@index')->name('home')->middleware('verified');

/* --------------------- Common/User Routes END -------------------------------- */

/* ----------------------- Admin Routes START -------------------------------- */

Route::prefix('/admin')->name('admin.')->namespace('Admin')->group(function () {

    /**
     * Admin Auth Route(s)
     */
    Route::namespace('Auth')->group(function () {

        //Login Routes
        Route::get('/login', 'LoginController@showLoginForm')->name('login');
        Route::post('/login', 'LoginController@login');
        Route::post('/logout', 'LoginController@logout')->name('logout');

        //Register Routes
        // Route::get('/register','RegisterController@showRegistrationForm')->name('register');
        // Route::post('/register','RegisterController@register');

        //Forgot Password Routes
        Route::get('/password/reset', 'ForgotPasswordController@showLinkRequestForm')->name('password.request');
        Route::post('/password/email', 'ForgotPasswordController@sendResetLinkEmail')->name('password.email');

        //Reset Password Routes
        Route::get('/password/reset/{token}', 'ResetPasswordController@showResetForm')->name('password.reset');
        Route::post('/password/reset', 'ResetPasswordController@reset')->name('password.update');

        // Email Verification Route(s)
        Route::get('email/verify', 'VerificationController@show')->name('verification.notice');
        Route::get('email/verify/{id}', 'VerificationController@verify')->name('verification.verify');
        Route::get('email/resend', 'VerificationController@resend')->name('verification.resend');
    });

    Route::get('/dashboard', 'HomeController@index')->name('home');
    Route::get('/settings', 'HomeController@settings')->name('settings');
    Route::post('/updateSettings', 'HomeController@updateSettings')->name('updateSettings');

    // User Management
    Route::get('/users', 'UserController@index')->name('user');
    Route::get('/getUserListings', 'UserController@getUserListings')->name('getUserListings');
    Route::get('/user/{id}', 'UserController@show')->name('user.show');
    Route::get('/user/{id}/edit', 'UserController@edit')->name('user.edit');
    Route::post('/user/{id}/edit', 'UserController@doEdit')->name('user.do-edit');
    Route::get('/user/{id}/delete', 'UserController@delete')->name('user.delete');

    // NPO Management
    Route::get('/npo-listings', 'NPOController@index')->name('npo');
    Route::get('/getNPOListings', 'NPOController@getNPOListings')->name('getNPOListings');
    Route::get('/add-npo', 'NPOController@add')->name('npo.add');
    Route::post('/addNpo', 'NPOController@addNpo')->name('npo.do-addNpo');
    Route::get('/npo/{id}', 'NPOController@show')->name('npo.show');
    Route::get('/npo/{id}/edit', 'NPOController@edit')->name('npo.edit');
    Route::post('/npo/{id}/edit', 'NPOController@doEdit')->name('npo.do-edit');
    Route::get('/npo/{id}/delete', 'NPOController@delete')->name('npo.delete');

    // NPO Categories
    Route::get('/npo-categories', 'NpoCategoriesController@index')->name('npocategories');
    Route::get('/getNPOCategoryListings', 'NpoCategoriesController@getNPOCategoryListings')->name('getNPOCategoryListings');
    Route::get('/add-npo-category', 'NpoCategoriesController@create')->name('npocategories.add-npo-category');
    Route::post('/createNpoCategory', 'NpoCategoriesController@createNpoCategory')->name('createNpoCategory');
    Route::get('/npo-categories/{id}/edit', 'NpoCategoriesController@edit')->name('npocategories.edit-npo-category');
    Route::post('/npo-categories/{id}/edit', 'NpoCategoriesController@updateNpoCategory')->name('updateNpoCategory');


    // NPO Coupons
    Route::get('/coupons', 'CouponController@index')->name('coupons');
    Route::get('/getCouponListings', 'CouponController@getCouponListings')->name('getCouponListings');
    Route::get('/add-coupon', 'CouponController@create')->name('coupons.add-coupon');
    Route::post('/createCoupon', 'CouponController@createCoupon')->name('createCoupon');
    Route::get('/coupons/{id}/edit', 'CouponController@edit')->name('coupons.edit-coupon');
    Route::post('/coupons/{id}/edit', 'CouponController@updateCoupon')->name('updateCoupon');   

    // Giveaways
    Route::get('/giveaways', 'GiveawaysController@index')->name('giveaways');
    Route::get('/getGiveawaysListings', 'GiveawaysController@getGiveawaysListings')->name('getGiveawaysListings');
    Route::get('/add-giveaway', 'GiveawaysController@create')->name('giveaways.add-giveaway');
    Route::post('/createGiveaway', 'GiveawaysController@createGiveaway')->name('createGiveaway');
    Route::get('/giveaways/{id}/edit', 'GiveawaysController@edit')->name('giveaways.edit-giveaway');
    Route::post('/giveaways/{id}/edit', 'GiveawaysController@updateGiveaway')->name('updateGiveaway'); 


    // Champions
    Route::get('/champions', 'ChampionsController@index')->name('champions');
    Route::get('/getChampionsListings', 'ChampionsController@getChampionsListings')->name('getChampionsListings');
    Route::get('/add-champion', 'ChampionsController@create')->name('champions.add-champion');
    Route::post('/createChampion', 'ChampionsController@createChampion')->name('createChampion');
    Route::get('/champions/{id}/edit', 'ChampionsController@edit')->name('champions.edit-champion');
    Route::post('/champions/{id}/edit', 'ChampionsController@updateChampion')->name('updateChampion'); 


    //Put all of your admin routes here...

});

/* ----------------------- Admin Routes END -------------------------------- */

app/Npo.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Notifications\Notifiable;
use Illuminate\Foundation\Auth\User as Authenticatable;

class Npo extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'organization_name', 'npo_logo', 'npo_contact', 'npo_email', 'npo_phone' , 'password', 'npo_city', 'npo_state', 'npo_zipcode', 'npo_website_url', 'npo_category', 'npo_charity_navigator_rating', 'npo_mission_statement', 'npo_about_us', 'npo_events_and_programs', 'npo_status'
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password'
    ];
}

app/Http/Controllers/Admin/NPOController.php
<?php

namespace App\Http\Controllers\Admin;

use Illuminate\Http\Request;
use App\Http\Requests\Admin\UpdateUserRequest;
use App\Http\Controllers\Controller;
use App\User;
use App\NpoCategories;
use App\NonProfits;
use Yajra\DataTables\Facades\DataTables;
use Illuminate\Support\Facades\Hash;
use DB;
use App\Traits\UploadTrait; // Upload Image

class NPOController extends Controller
{

    use UploadTrait;
    /**
     * Only Authenticated users for "admin" guard 
     * are allowed.
     * 
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth:admin');
    }

    /**
     * Show Admin User Listings.
     * 
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('admin.npo.index');
    }


    public function getNPOListings()
    {
        //$users = NonProfits::select('*');
        

        $users = \DB::table('non_profits')
        ->join('npo_categories', 'non_profits.npo_category', '=', 'npo_categories.id')
        ->select('non_profits.*', 'npo_categories.category_name')
        ->get();

        return DataTables::of($users)
            ->addColumn('action', 'admin.npo.action')
            ->addColumn('npo_first_name', function ($data) {
                return ($data->npo_first_name) . ' ' . ($data->npo_last_name);
            })
            ->rawColumns(['action', 'npo_first_name'])
            ->toJson();
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $npoById = NonProfits::find($id);
        return view('admin.npo.view', compact('npoById'));
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function add()
    {
        $getNpoCategories = NpoCategories::all()->where('category_status', '=', 'active');
        return view('admin.npo.add')->with(compact('getNpoCategories'));
    }

    public function addNpo(Request $request)
    {

        $newNpo = new NonProfits;

        $validateUrl = '/^(https?:\/\/)?([\da-z\.-]+)\.([a-z\.]{2,6})([\/\w \.-]*)*\/?$/';

        $request->validate(
            [
                'organization_name' => 'required',
                'npo_first_name' => 'required',
                'npo_last_name' => 'required',
                'npo_email' => 'required|unique:non_profits',
                'npo_phone' => 'required|unique:non_profits',
                'password' => 'required',
                'npo_city' => 'required',
                'npo_state' => 'required',
                'npo_zipcode' => 'required',
                'npo_website_url' => 'required|regex:' . $validateUrl,
                'npo_category' => 'required',
                'npo_charity_navigator_rating' => 'required',
                'npo_mission_statement' => 'required',
                'npo_about_us' => 'required',
                'npo_celebrity_or_influential_supporters_include' => 'required',
                'npo_major_coporate_partners_include' => 'required',
                'npo_affiliate_code' => 'nullable',
                'npo_logo' => 'image|mimes:jpeg,png,jpg,gif',
                'npo_image_or_video' => 'mimes:jpeg,png,jpg,gif,mp4,mov,flv,m3u8,ts,3gp,avi,wmv | max:10000'
            ],
            [
                'organization_name.required' => 'Organization Name is required.',
                'npo_first_name.required' => 'First Name is required.',
                'npo_last_name.required' => 'Last Name is required.',
                'npo_email.required' => 'Email is required.',
                'npo_email.email' => 'Invalid Email Address.',
                'npo_phone.required' => 'Phone is required.',
                'npo_city.required' => 'City is required.',
                'npo_state.required' => 'State is required.',
                'npo_zipcode.required' => 'Zip Code is required.',
                'npo_website_url.required' => 'Website Url is required.',
                'npo_website_url.regex' => 'Invalid Website Url.',
                'npo_category.required' => 'Category is required.',
                'npo_charity_navigator_rating.required' => 'Charity Navigator Rating is required.',
                'npo_mission_statement.required' => 'Mission Statement is required.',
                'npo_about_us.required' => 'About Us is required.',
                'npo_celebrity_or_influential_supporters_include.required' => 'Celebrity or Influential Supporters include is required.',
                'npo_major_coporate_partners_include.required' => 'Major Corporate Partners / Sponsors Include is required.',
                'npo_logo.image' => 'Invalid Image.',
                'npo_image_or_video.mimes' => 'Invalid Image or Video.',
                'npo_image_or_video.max' => 'Maximum Image or Video size is 10 Mb.',
            ]
        );


        // Check if a profile image has been uploaded
        if ($request->has('npo_logo')) {
            // Get image file
            $image = $request->file('npo_logo');
            // Make a image name based on user name and current timestamp
            $name = 'npo_logo_' . time();
            // Define folder path
            $folder = '/app-assets/npo/';
            // Make a file path where image will be stored [ folder path + file name + file extension]
            $filePath = $folder . $name . '.' . $image->getClientOriginalExtension();
            // Upload image
            $this->uploadOne($image, $folder, 'public', $name);
            // Set user profile image path in database to filePath
            $newNpo->npo_logo = $filePath;
        }

        // Check if a NPO image or video has been uploaded
        if ($request->has('npo_image_or_video')) {
            // Get image file
            $image = $request->file('npo_image_or_video');
            // Make a image name based on user name and current timestamp
            $name = 'npo_image_or_video_' . time();
            // Define folder path
            $folder = '/app-assets/npo/';
            // Make a file path where image will be stored [ folder path + file name + file extension]
            $filePath = $folder . $name . '.' . $image->getClientOriginalExtension();
            // Upload image
            $this->uploadOne($image, $folder, 'public', $name);
            // Set user profile image path in database to filePath
            $newNpo->npo_image_or_video = $filePath;
        }

        $newNpo->organization_name = $request->input('organization_name');
        $newNpo->npo_first_name = $request->input('npo_first_name');
        $newNpo->npo_last_name = $request->input('npo_last_name');
        $newNpo->npo_email = $request->input('npo_email');
        $newNpo->npo_phone = $request->input('npo_phone');
        $newNpo->password = Hash::make($request->input('password'));
        $newNpo->npo_city = $request->input('npo_city');
        $newNpo->npo_state = $request->input('npo_state');
        $newNpo->npo_zipcode = $request->input('npo_zipcode');
        $newNpo->npo_category = $request->input('npo_category');
        $newNpo->npo_website_url = $request->input('npo_website_url');
        $newNpo->npo_charity_navigator_rating = $request->input('npo_charity_navigator_rating');
        $newNpo->npo_mission_statement = $request->input('npo_mission_statement');
        $newNpo->npo_about_us = $request->input('npo_about_us');
        $newNpo->npo_celebrity_or_influential_supporters_include = $request->input('npo_celebrity_or_influential_supporters_include');
        $newNpo->npo_major_coporate_partners_include = $request->input('npo_major_coporate_partners_include');
        $newNpo->npo_affiliate_code = $request->input('npo_affiliate_code');

        $newNpo->save();

        return redirect()
            ->intended(route('admin.npo'))
            ->with('status', $request->input('organization_name') . ' added successfully.');
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $getNpoCategories = NpoCategories::all()->where('category_status', '=', 'active');
        $npoById = NonProfits::find($id);
        return view('admin.npo.view', compact('npoById'))->with(compact('getNpoCategories'));
    }

    public function doEdit($id, Request $request)
    {

        

        $newNpo = NonProfits::find($id);

        $validateUrl = '/^(https?:\/\/)?([\da-z\.-]+)\.([a-z\.]{2,6})([\/\w \.-]*)*\/?$/';

       

        $request->validate(
            [
                'organization_name' => 'required',
                'npo_first_name' => 'required',
                'npo_last_name' => 'required',
                'npo_email' => 'required|email',
                'npo_phone' => 'required',                
                'password' => 'nullable',
                'npo_city' => 'required',
                'npo_state' => 'required',
                'npo_zipcode' => 'required',
                'npo_website_url' => 'required|regex:' . $validateUrl,
                'npo_category' => 'required',
                'npo_charity_navigator_rating' => 'required',
                'npo_mission_statement' => 'required',
                'npo_about_us' => 'required',
                'npo_celebrity_or_influential_supporters_include' => 'required',
                'npo_major_coporate_partners_include' => 'required',
                'npo_status' => 'required',
                'npo_affiliate_code' => 'nullable',
                'npo_logo' => 'image|mimes:jpeg,png,jpg,gif',
                'npo_image_or_video' => 'mimes:jpeg,png,jpg,gif,mp4,mov,flv,m3u8,ts,3gp,avi,wmv | max:10000'
            ],
            [
                'organization_name.required' => 'Organization Name is required.',
                'npo_first_name.required' => 'First Name is required.',

resources/views/admin/npo/action.blade.php
<div class="text-center">
    <?php /* <a class="btn btn-primary btn-sm" href="javascript:void(0)">
        <i class="fas fa-folder">
        </i>
        View Donations
    </a> */ ?>

    <a class="btn btn-info btn-sm" href="{{ route('admin.npo.edit', $id) }}">
        <i class="fas fa-pencil-alt">
        </i>
        Edit
    </a>
    
    <?php /* <a data-name="{{ $first_name }} {{ $last_name }}" data-url="{{ route('admin.user.delete', $id)  }}" href="#" class="btn icon-btn btn-sm btn-outline-primary act-delete-user"> <i class="fa fa-trash-alt"></i> </a> */ ?>
</div>

resources/views/admin/npo/index.blade.php
@extends('layouts.app')


@section('header')
<!-- DataTables -->
<link rel="stylesheet" href="{{asset('app-assets/admin/plugins/datatables-bs4/css/dataTables.bootstrap4.min.css')}}">
<link rel="stylesheet" href="{{asset('app-assets/admin/plugins/datatables-responsive/css/responsive.bootstrap4.min.css')}}">
@endsection

@section('content')


<!-- Content Wrapper. Contains page content -->
<div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
        <div class="container-fluid">
            <div class="row mb-2">
                <div class="col-sm-6">
                    <h1>NPO Listings</h1>
                </div>
                <div class="col-sm-6">
                    <ol class="breadcrumb float-sm-right">
                        <li class="breadcrumb-item"><a href="#">Home</a></li>
                        <li class="breadcrumb-item active">NPO Listings</li>
                    </ol>
                </div>
            </div>
            <div class="row">
                <div class="col-sm-2 float-sm-right">
                    <a class="btn btn-block btn-info " href="{{ route('admin.npo.add') }}">
                        {{ __('Add New NPO') }}
                    </a>

                </div>
            </div>
        </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
        <div class="row">
            <div class="col-12">
                <div class="card">

                    <div class="card-body npo_listings_div" id="admin-users-list-wrap">
                        <table id="table-manage-users" class="table table-bordered table-striped" data-url="{{ route('admin.getNPOListings') }}">
                            <thead>
                                <tr>
                                    <th>ID</th>
                                    <th>Name</th>
                                    <th>Contact</th>
                                    <th>Email</th>
                                    <th>Category</th>
                                    <th>Rating</th>
                                    <th>Phone</th>
                                    <th>City</th>
                                    <th>State</th>
                                    <th>Status</th>
                                    <th>Action</th>
                                </tr>
                            </thead>
                            


                        </table>
                    </div>
                    <!-- /.card-body -->
                </div>
                <!-- /.card -->
            </div>
            <!-- /.col -->
        </div>
        <!-- /.row -->
    </section>
    <!-- /.content -->
</div>
<!-- /.content-wrapper -->



@endsection

@section('footer')
<!-- DataTables -->
<script src="{{asset('app-assets/admin/plugins/datatables/jquery.dataTables.min.js')}}"></script>
<script src="{{asset('app-assets/admin/plugins/datatables-bs4/js/dataTables.bootstrap4.min.js')}}"></script>
<script src="{{asset('app-assets/admin/plugins/datatables-buttons/js/dataTables.buttons.min.js')}}"></script>
<script src="{{asset('app-assets/admin/plugins/datatables-buttons/js/buttons.flash.min.js')}}"></script>
<script src="{{asset('app-assets/admin/plugins/datatables-responsive/js/dataTables.responsive.min.js')}}"></script>
<script src="{{asset('app-assets/admin/plugins/datatables-responsive/js/responsive.bootstrap4.min.js')}}"></script>
<script src="{{asset('app-assets/admin/plugins/datatables-fixedheader/js/dataTables.fixedHeader.min.js')}}"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/jszip/3.1.3/jszip.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/pdfmake/0.1.53/pdfmake.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/pdfmake/0.1.53/vfs_fonts.js"></script>
<script src="https://cdn.datatables.net/buttons/1.6.1/js/buttons.html5.min.js"></script>
<script src="https://cdn.datatables.net/buttons/1.6.1/js/buttons.print.min.js"></script>
<script src="{{asset('app-assets/admin/pages/npo.js')}}"></script>
@endsection